//!
//! @file usb_device_task.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قUSBuǗ܂B
//!
//! USBƂUSBνĂ̐Vv̓𒲂ׂ܂B\ݒ(Setup)vN
//! ƁA̍Ƃusb_standard_request.çقɊ܂܂邱̍\ݒ̏J
//! n܂B̸׽Lv̧قŏ܂B
//!
//! @version 1.2 at90usb128-demo-touchscreen-1_0_0 $Id: usb_device_task.c,v 1.2 2006/03/13 10:19:27 rletendu Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_device_task.h"
#include "usb_task.h"

#include "usb_drv.h"
#include "usb_descriptors.h"
#include "usb_standard_request.h"
#include "pll_drv.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

//!
//!  : (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected͂̑̏ꍇFALSEɐݒ肳܂B
//!/
bit usb_connected;

//!
//!  : (U8) usb_configuration_nb
//! ̒l0ƈႤUSBuɂĎgpUSB`Ԑݒ萔i[A͑
//! u`Ԃ(ڑF)邱ƂӖ܂B
//! USB_DEVICE_FEATURE == ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;

//_____ 錾 __________________________________________________________________

//!
//! @brief ̊֐USBuƼъ荞݂܂B
//!
//! ̊֐USBUSB荞݂܂BړI͓`ԊǗ
//! ɓK؂USBۂ𑗂邽߂USBڑoƂłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void usb_device_task_init (void)
{
	Enable_interrupt();
	Usb_disable();
	Usb_enable();
	Usb_select_device();
	Usb_enable_vbus_interrupt();
	Enable_interrupt();
}

//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂BړI͖ړI͓`
//! ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//! xVBUSڑVBUSω荞݂܂VBUS Highق̂ǂ炩ɂČo
//! ƁAuJn֐s܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_start_device (void)
{
	Pll_start_auto();
	Wait_pll_ready();
	Usb_unfreeze_clock();
	Usb_enable_suspend_interrupt();
	Usb_enable_reset_interrupt();
	usb_init_device();						// USB̴߲0`Ԑݒ
	Usb_attach();
	usb_connected = FALSE;
}

//! @brief USBuǗ̓(_)
//!
//! ̊֐USBǗ̓(_)łBeUSBۂ͓K؂ȊJn邽߂ɂ
//! Œׂ܂B萧߲Ăō\ݒ(Setup)vNꍇAusb_
//! standard_request.çٓusb_process_request()֐Ă΂܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_device_task (void)
{
	if (Is_usb_vbus_high()&& usb_connected==FALSE)
	{
		usb_connected = TRUE;
		Usb_vbus_on_action();
		Usb_send_event(EVT_USB_POWERED);
		Usb_enable_reset_interrupt();
		Usb_attach();
	}

	if(Is_usb_event(EVT_USB_RESET))
	{
		Usb_ack_event(EVT_USB_RESET);
		Usb_reset_endpoint(0);
		usb_configuration_nb=0;
	}

	// ͑u(ڑF)̂߂̐ڑ
	Usb_select_endpoint(EP_CONTROL);
	if (Is_usb_receive_setup())
	{
		usb_process_request();
	}
}
